<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>Request.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server</a> &gt; <span class="el_source">Request.java</span></div><h1>Request.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server;

import java.nio.ByteBuffer;
import java.util.List;

import org.apache.jute.Record;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.apache.zookeeper.KeeperException;
import org.apache.zookeeper.ZooDefs.OpCode;
import org.apache.zookeeper.data.Id;
import org.apache.zookeeper.txn.TxnHeader;

/**
 * This is the structure that represents a request moving through a chain of
 * RequestProcessors. There are various pieces of information that is tacked
 * onto the request as it is processed.
 */
public class Request {
<span class="fc" id="L38">    private static final Logger LOG = LoggerFactory.getLogger(Request.class);</span>

<span class="fc" id="L40">    public final static Request requestOfDeath = new Request(null, 0, 0, 0,</span>
            null, null);

    /**
     * @param cnxn
     * @param sessionId
     * @param xid
     * @param type
     * @param bb
     */
    public Request(ServerCnxn cnxn, long sessionId, int xid, int type,
<span class="fc" id="L51">            ByteBuffer bb, List&lt;Id&gt; authInfo) {</span>
<span class="fc" id="L52">        this.cnxn = cnxn;</span>
<span class="fc" id="L53">        this.sessionId = sessionId;</span>
<span class="fc" id="L54">        this.cxid = xid;</span>
<span class="fc" id="L55">        this.type = type;</span>
<span class="fc" id="L56">        this.request = bb;</span>
<span class="fc" id="L57">        this.authInfo = authInfo;</span>
<span class="fc" id="L58">    }</span>

    public final long sessionId;

    public final int cxid;

    public final int type;

    public final ByteBuffer request;

    public final ServerCnxn cnxn;

    public TxnHeader hdr;

    public Record txn;

<span class="fc" id="L74">    public long zxid = -1;</span>

    public final List&lt;Id&gt; authInfo;

<span class="fc" id="L78">    public final long createTime = System.currentTimeMillis();</span>
    
    private Object owner;
    
    private KeeperException e;

    public Object getOwner() {
<span class="fc" id="L85">        return owner;</span>
    }
    
    public void setOwner(Object owner) {
<span class="fc" id="L89">        this.owner = owner;</span>
<span class="fc" id="L90">    }</span>

    /**
     * is the packet type a valid packet in zookeeper
     * 
     * @param type
     *                the type of the packet
     * @return true if a valid packet, false if not
     */
    static boolean isValid(int type) {
        // make sure this is always synchronized with Zoodefs!!
<span class="pc bpc" id="L101" title="1 of 3 branches missed.">        switch (type) {</span>
        case OpCode.notification:
<span class="nc" id="L103">            return false;</span>
        case OpCode.create:
        case OpCode.delete:
        case OpCode.createSession:
        case OpCode.exists:
        case OpCode.getData:
        case OpCode.check:
        case OpCode.multi:
        case OpCode.setData:
        case OpCode.sync:
        case OpCode.getACL:
        case OpCode.setACL:
        case OpCode.getChildren:
        case OpCode.getChildren2:
        case OpCode.ping:
        case OpCode.closeSession:
        case OpCode.setWatches:
<span class="fc" id="L120">            return true;</span>
        default:
<span class="fc" id="L122">            return false;</span>
        }
    }

    static boolean isQuorum(int type) {
<span class="fc bfc" id="L127" title="All 3 branches covered.">        switch (type) {</span>
        case OpCode.exists:
        case OpCode.getACL:
        case OpCode.getChildren:
        case OpCode.getChildren2:
        case OpCode.getData:
<span class="fc" id="L133">            return false;</span>
        case OpCode.error:
        case OpCode.closeSession:
        case OpCode.create:
        case OpCode.createSession:
        case OpCode.delete:
        case OpCode.setACL:
        case OpCode.setData:
        case OpCode.check:
        case OpCode.multi:
<span class="fc" id="L143">            return true;</span>
        default:
<span class="fc" id="L145">            return false;</span>
        }
    }
    
    static String op2String(int op) {
<span class="pc bpc" id="L150" title="14 of 19 branches missed.">        switch (op) {</span>
        case OpCode.notification:
<span class="nc" id="L152">            return &quot;notification&quot;;</span>
        case OpCode.create:
<span class="fc" id="L154">            return &quot;create&quot;;</span>
        case OpCode.setWatches:
<span class="nc" id="L156">            return &quot;setWatches&quot;;</span>
        case OpCode.delete:
<span class="fc" id="L158">            return &quot;delete&quot;;</span>
        case OpCode.exists:
<span class="nc" id="L160">            return &quot;exists&quot;;</span>
        case OpCode.getData:
<span class="nc" id="L162">            return &quot;getData&quot;;</span>
        case OpCode.check:
<span class="nc" id="L164">            return &quot;check&quot;;</span>
        case OpCode.multi:
<span class="fc" id="L166">            return &quot;multi&quot;;</span>
        case OpCode.setData:
<span class="fc" id="L168">            return &quot;setData&quot;;</span>
        case OpCode.sync:
<span class="nc" id="L170">              return &quot;sync:&quot;;</span>
        case OpCode.getACL:
<span class="nc" id="L172">            return &quot;getACL&quot;;</span>
        case OpCode.setACL:
<span class="fc" id="L174">            return &quot;setACL&quot;;</span>
        case OpCode.getChildren:
<span class="nc" id="L176">            return &quot;getChildren&quot;;</span>
        case OpCode.getChildren2:
<span class="nc" id="L178">            return &quot;getChildren2&quot;;</span>
        case OpCode.ping:
<span class="nc" id="L180">            return &quot;ping&quot;;</span>
        case OpCode.createSession:
<span class="nc" id="L182">            return &quot;createSession&quot;;</span>
        case OpCode.closeSession:
<span class="nc" id="L184">            return &quot;closeSession&quot;;</span>
        case OpCode.error:
<span class="nc" id="L186">            return &quot;error&quot;;</span>
        default:
<span class="nc" id="L188">            return &quot;unknown &quot; + op;</span>
        }
    }

    @Override
    public String toString() {
<span class="fc" id="L194">        StringBuilder sb = new StringBuilder();</span>
<span class="fc" id="L195">        sb.append(&quot;sessionid:0x&quot;).append(Long.toHexString(sessionId))</span>
<span class="fc" id="L196">            .append(&quot; type:&quot;).append(op2String(type))</span>
<span class="fc" id="L197">            .append(&quot; cxid:0x&quot;).append(Long.toHexString(cxid))</span>
<span class="pc bpc" id="L198" title="1 of 2 branches missed.">            .append(&quot; zxid:0x&quot;).append(Long.toHexString(hdr == null ?</span>
<span class="fc" id="L199">                    -2 : hdr.getZxid()))</span>
<span class="pc bpc" id="L200" title="1 of 2 branches missed.">            .append(&quot; txntype:&quot;).append(hdr == null ?</span>
<span class="fc" id="L201">                    &quot;unknown&quot; : &quot;&quot; + hdr.getType());</span>

        // best effort to print the path assoc with this request
<span class="fc" id="L204">        String path = &quot;n/a&quot;;</span>
<span class="pc bpc" id="L205" title="4 of 8 branches missed.">        if (type != OpCode.createSession</span>
                &amp;&amp; type != OpCode.setWatches
                &amp;&amp; type != OpCode.closeSession
                &amp;&amp; request != null
<span class="fc bfc" id="L209" title="All 2 branches covered.">                &amp;&amp; request.remaining() &gt;= 4)</span>
        {
            try {
                // make sure we don't mess with request itself
<span class="fc" id="L213">                ByteBuffer rbuf = request.asReadOnlyBuffer();</span>
<span class="fc" id="L214">                rbuf.clear();</span>
<span class="fc" id="L215">                int pathLen = rbuf.getInt();</span>
                // sanity check
<span class="pc bpc" id="L217" title="2 of 4 branches missed.">                if (pathLen &gt;= 0</span>
                        &amp;&amp; pathLen &lt; 4096
<span class="pc bpc" id="L219" title="1 of 2 branches missed.">                        &amp;&amp; rbuf.remaining() &gt;= pathLen)</span>
                {
<span class="fc" id="L221">                    byte b[] = new byte[pathLen];</span>
<span class="fc" id="L222">                    rbuf.get(b);</span>
<span class="fc" id="L223">                    path = new String(b);</span>
                }
<span class="nc" id="L225">            } catch (Exception e) {</span>
                // ignore - can't find the path, will output &quot;n/a&quot; instead
<span class="fc" id="L227">            }</span>
        }
<span class="fc" id="L229">        sb.append(&quot; reqpath:&quot;).append(path);</span>

<span class="fc" id="L231">        return sb.toString();</span>
    }

    public void setException(KeeperException e) {
<span class="fc" id="L235">        this.e = e;</span>
<span class="fc" id="L236">    }</span>
	
    public KeeperException getException() {
<span class="fc" id="L239">        return e;</span>
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>